from reaper_python import *

import sys
sys.argv=["Main"]

graphics = False   #  TURN LOADING BG GRAPHIC AND ICON THAT CAUSE TROUBLE ON/OFF WITH THIS


import tkinter
from tkinter import ttk, Toplevel, font
    
from sws_python import *
from contextlib import contextmanager

if graphics:  import _getdirectory_

from ReaChord_Functions import *


#########################################################################################################################################


class ReaChord:
    """
    ReaChorder Main Window
    """
        
    def __init__(self, root):
        self.msg('__init__')
        self.root = root
        self.root.title('ReaChorder')
        global graphics
        if graphics:
            self.resource_path = _getdirectory_.module_path() + '/' #+"/resources/"
            fn = (self.resource_path + 'icon.gif')
            self.icon = tkinter.PhotoImage(file=fn)
            self.root.tk.call('wm', 'iconphoto', root._w, self.icon)
            ttk.Frame(self.root)
            fn = (self.resource_path + 'bg_740x300.gif')
            self.bg = tkinter.PhotoImage(file=fn)
            self.bgLabel = ttk.Label(self.root, image=self.bg, borderwidth = 0)
            self.bgLabel.place(x=0, y=0, relwidth=1, relheight=1)
            self.bgLabel.bind("<ButtonPress-1>", self.StartMove)
            self.bgLabel.bind("<ButtonRelease-1>", self.StopMove)
            self.bgLabel.bind("<B1-Motion>", self.OnMotion)
            self.bgLabel.pack()
            self.bgLabel.pack_propagate(False)
        else:
            self.img = None
            ttk.Frame(self.root, borderwidth=5, relief="sunken", width=740,height=300).pack()
            self.bgLabel = self.root #ttk.Label(self.root, borderwidth = 0) 

        self.rc = RC()  #init this b4 widgets so they can get tuples from it
        self.init_widgets()

    
    def init_widgets(self):        
        self.txt2 = tkinter.Text(self.bgLabel, width='49', height='1')
        self.txt2.place(x=324, y=23)
        
        self.btns = ttk.Button(self.bgLabel,  text='Draw chords into MIDI take...', width='25')
        self.btns.place(x=562, y=260) 
        self.btns.bind('<Button-1>', lambda event: self.drawMidiNow())

        self.btns1 = ttk.Button(self.bgLabel, text='Propose chord progression', width='25')
        self.btns1.place(x=35, y=260)  
        self.btns1.bind('<Button-1>', lambda event: self.getVals())

        self.btnClose = ttk.Button(self.bgLabel, text='Settings', width='10')
        self.btnClose.place(x=440, y=260)  
        self.btnClose.bind('<Button-1>', lambda event: self.ShowSettings())
        
        self.btns3 = ttk.Button(self.bgLabel, text='Clear', width='5')
        self.btns3.place(x=520, y=260)  
        self.btns3.bind('<Button-1>', lambda event: self.cleanbox())

        self.txt = tkinter.Text(self.bgLabel, width='60', height='12')
        self.txt.place(x=235, y=50)
        self.txt.config(state="disabled") #set read-only
  
        appHighlightFont = font.Font(family='Helvetica', size=16)
        tp0 = ttk.Label(self.bgLabel, text='',font=appHighlightFont)
        tp0.place(x=20, y=15)

        
        
        if graphics: 
            self.cbp1 = ttk.LabelFrame(self.bgLabel)
            self.cbp1.place(x=80, y=50)
            comboWidth = 15
        else:
            appHighlightFont = font.Font(family='Helvetica', size=8)
            tp3 = ttk.Label(self.bgLabel, text='All chords in Key:',font=appHighlightFont)
            tp3.place(x=235, y=23)
            self.cbp1 = ttk.LabelFrame(self.bgLabel, text='Create')
            self.cbp1.place(x=20, y=50)
            appHighlightFont = font.Font(family='Helvetica', size=16)
            tp0 = ttk.Label(self.root, text='ReaChorder',font=appHighlightFont)
            tp0.place(x=20, y=15)
            comboWidth = 25
        self.cbMoods = ttk.Combobox(self.cbp1, values=RC.Moods, state='readonly', width=comboWidth)
        self.cbMoods.current(0)
        self.cbMoods.pack(pady=5, padx=10)
        
  
        self.cbInKey = ttk.Combobox(self.cbp1, values=RC.InKey, state='readonly', width=comboWidth)
        self.cbInKey.current(0)
        self.cbInKey.pack(pady=5, padx=10)

        self.cbScales = ttk.Combobox(self.cbp1, values=RC.Scales, state='readonly', width=comboWidth)
        self.cbScales.current(0)
        self.cbScales.pack(pady=5, padx=10)
        
        self.cbStructure = ttk.Combobox(self.cbp1, values=RC.entriesStructures, state='readonly', width=comboWidth)
        self.cbStructure.current(0)
        self.cbStructure.pack(pady=5, padx=10)
    
    
    def ShowSettings(self):
        #self.winSettings.run()
        winSettings = tkWindow('Settings',self.img, self.rc)
        winSettings.run()
        self.rc.StoreSettings()
        
        
    def msg(self, m):
        msg(m)
        
        
    def StartMove(self, event):
        self.msg('def StartMove')
        self.x = event.x
        self.y = event.y


    def StopMove(self, event):
        self.msg('def StopMove')
        self.x = None
        self.y = None


    def OnMotion(self, event):
        global root
        #self.msg('def OnMotion')
        deltax = event.x - self.x
        deltay = event.y - self.y
        x = root.winfo_x() + deltax
        y = root.winfo_y() + deltay
        root.geometry("+%s+%s" % (x, y))
        
        
    def getVals(self):
        self.msg('getVals - Enter')
        self.txt.config(state="normal") #set read-write
        self.cleanbox();
        self.txt.insert(tkinter.INSERT, self.rc.drawChordText(str(self.cbMoods.current()), str(self.cbInKey.current()), \
                                                      str(self.cbScales.get()),str(self.cbStructure.current())))
        self.txt2.insert(tkinter.INSERT, self.rc.drawChordTextKey(str(self.cbMoods.current()), str(self.cbInKey.current()),\
                                                          str(self.cbScales.get()),str(self.cbStructure.current())))
        self.txt.config(state="disabled") #set read-only
        self.msg('getVals - Exit')
        
        
    def getValsII(self):
        self.msg('getValsII')
        self.txt.config(state="normal") #set read-write
        self.cleanbox();
        self.txt.insert(tkinter.INSERT, self.rc.drawChordText(str(self.cbMoods.current()),     str(self.cbInKey.current()),\
                                                              str(self.cbScales.get()),        str(self.cbStructure.current())))
        self.txt2.insert(tkinter.INSERT, self.rc.drawChordTextKey(str(self.cbMoods.current()), str(self.cbInKey.current()),\
                                                              str(self.cbScales.get()),        str(self.cbStructure.current())))
        self.txt.config(state="disabled") #set read-only
       
       
    def close(self):
        global root
        root.destroy()
        
       
    def cleanbox(self):
        msg('cleanbox')
        self.txt.delete('1.0', '50.0')
        self.txt2.delete('1.0', '50.0')
        
        
    def drawMidi(self):
        self.txt.insert(tkinter.INSERT, self.rc.drawChordText())
                
        
    def drawMidiNow(self):
        msg('drawMidiNow - Enter')
        self.rc.drawMidi(str(self.cbMoods.current()), str(self.cbInKey.current()),str(self.cbScales.get()),self.cbStructure.current(), 0)
        msg('drawMidiNow -Exit')

 
######################################################################################################################################### 
 
 
class tkWindow(Toplevel):
    """
    Settings Window
    """
    def __init__(self,name,icon, rc, **k):
        Toplevel.__init__(self,border=4,**k)
        self.title(name)
        self.rc = rc
        if icon is not None:
            self.tk.call('wm', 'iconphoto', self._w, icon)
        
        i=0
        l = ttk.Label(self, text="Draw")
        l.grid(row=i, column=0)
        l = ttk.Label(self, text="Channel")
        l.grid(row=i, column=1)
        i+=1
        
       
        self.pCheckBox = self.pLabel = self.pSlider = 0  #declare positions in list - populated below...
        self.pStringVars=0
        
        self.lControls = {} #dict of list of controls
        self.stringVars = []
        for key, value in RC.Settings.items():
            self.lControls[key] = [] #create empty list in dict entry (scope?)
            p=0
            
            #checkButton
            self.pCheckBox = p
            p+=1
            v = tkinter.StringVar()
            self.stringVars.append(v)
            b = tkinter.Checkbutton(self, text=key, variable = v, onvalue=RC.TRUE, offvalue=RC.FALSE)
            try:
                self.lControls[key].append(v) #store stringvar instead of checkbox
            except Exception as e:
                msg("--- Exception StringVar in List")
                msg(e)
                  
            #slider (Scale)
            self.pSlider = p
            p+=1
            s=tkinter.Scale(self, from_=1, to=16, resolution = 1, showvalue=1, orient="horizontal")
            self.lControls[key].append(s)
            
            try:
                b.grid(row=i,column=(0), sticky='w')
            except Exception as e:
                msg("--- checkbox grid");msg(e)
            try:
                if key is not RC.REGION:
                    s.grid(row=i,column=1)
            except Exception as e:
                msg("--- slider grid");msg(e)

            i+=1
        #"""
        b = ttk.Button(self, text="Okay", command=self.Okay)
        b.grid(row=i, column=0)
        b = ttk.Button(self, text="Cancel", command=self.destroy)
        b.grid(row=i, column=1)
        
        self.GetSettings()     
        
        
    def GetSettings(self):
        i=0
        for key, lst in self.lControls.items():
            try:
                lst[0].set(RC.Settings[key][RC.pSettingsOnOff])
                #self.stringVars[i].set(RC.Settings[key][RC.pSettingsOnOff])
            except Exception as e:
                msg(e)
            i+=1
            try:
                lst[1].set(RC.Settings[key][RC.pSettingsChannel])
            except Exception as e:
                msg(e)
     
                
    def SetSettings(self):
        i=0
        for key, lst in self.lControls.items():
            msg('---')
            msg('KEY - ' + str(key))
                 
            try:
                RC.Settings[key][RC.pSettingsOnOff] = lst[0].get() #self.stringVars[i].get()
                msg('0 - ' + str(RC.Settings[key][RC.pSettingsOnOff]))
            except Exception as e:
                msg(e)
            i+=1
            try:
                RC.Settings[key][RC.pSettingsChannel] = lst[1].get()
                msg('1 - ' + str(RC.Settings[key][RC.pSettingsChannel]))
            except Exception as e:
                msg(e)
        self.rc.StoreSettings()
        
          
    def Okay(self):
        self.SetSettings()
        self.destroy()
        
        
    def run(self):
        self.deiconify()
        #self.master.withdraw() # hide real tk root
        self.attributes( '-topmost', 1 )
        self.lift()
        #self.center()
        self.focus()
        self.wait_window()
 
 
    def focus(self):
        self.grab_set()
        self.focus_set()
 
 
    def center(self):
        self.update_idletasks()
        w= self["width"]!=0 and self["width"] or self.winfo_width()
        h= self["height"]!=0 and self["height"] or self.winfo_height()
        ws,hs = self.winfo_screenwidth(),self.winfo_screenheight()
        self.geometry('%dx%d+%d+%d' % (w, h, (ws/2) - (w/2), (hs/2) - (h/2)))      



###############################################
###############################################

if __name__ == '__main__':
    root = tkinter.Tk()
    ReaChord(root)
    root.mainloop()
    
